package org.ow2.choreos.chordevelopment.analysis.depanalyzer.entity;

public class SubchoreographyStep extends Step{

	private SubChoreography subChoreography;
	private boolean expanded;
	
	public SubchoreographyStep(String ID, 
			SubChoreography subChoreography, 
			boolean expanded){
		
		this.ID = ID;
		this.subChoreography = subChoreography;
		this.expanded = expanded;
	}
	
	public SubChoreography getSubChoreography() {
		return subChoreography;
	}
	
	public boolean isExpanded(){
		return expanded;
	}
	
	@Override
	protected void plugIntoChoreography(ChoreographySchema chorSchema) {
		chorSchema.addSubchorStep(this);
	}
	
}