package it.univaq.di.choreos.coordinationprotocol.algorithm;

import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.State;

public class GlobalStateManager {
	
	private State globalState;
	
	public GlobalStateManager(State globalState) {
		super();
		this.globalState = globalState;
	}

	public State getGlobaState() {
		return globalState;
	}

	public void updateGlobalState(State state) {
		if (state==null) {
			return;
		}
		globalState = state;
	}
	
	public boolean isCurrentState(State state) {
		if (state.getName().equals(globalState.getName())) {
			return true;
		}
		return false;
	}

}
