package it.univaq.di.choreos.elts.strongsimulation;

import it.univaq.di.choreos.ELTS.State;

/**
 * 
 * @author Alexander Perucci
 * 
 */
public class StatesPairs {
	State firstState;
	State secondState;
	
	/**
	 * 
	 * @param firstState first state
	 * @param secondState second state
	 */
	public StatesPairs(State firstState, State secondState) {
		this.firstState=firstState;
		this.secondState=secondState;
	}
	
	/**
	 * 
	 * @return first state
	 */
	public State getFirstState(){
		return firstState;
	}
	
	/**
	 * 
	 * @return second state
	 */
	public State getSecondState(){
		return secondState;
	}
	
	@Override
	public boolean equals(Object o) {
        if (o == this) {
            return true;
        }
        if (!(o instanceof StatesPairs)) {
            return false;
        }
        StatesPairs statesPair = (StatesPairs) o;
        return statesPair.getFirstState() == firstState && statesPair.getSecondState()==secondState;
    }
}
