package it.univaq.di.choreos.synthesis.datamodel;

import java.util.List;

import javax.xml.bind.annotation.XmlRootElement;

@SuppressWarnings("serial")
@XmlRootElement
public class AbstractParticipant implements java.io.Serializable {

	private String abstractName;
	private String concreteName;
	private List<AbstractOperation> operations;

	public AbstractParticipant() {
		super();
	}

	public AbstractParticipant(String abstractName, String concreteName, List<AbstractOperation> operations) {
		super();
		this.abstractName = abstractName;
		this.concreteName = concreteName;
		this.operations = operations;
	}

	public String getAbstractName() {
		return abstractName;
	}

	public void setAbstractName(String abstractName) {
		this.abstractName = abstractName;
	}

	public String getConcreteName() {
		return concreteName;
	}

	public void setConcreteName(String concreteName) {
		this.concreteName = concreteName;
	}

	public List<AbstractOperation> getOperations() {
		return operations;
	}

	public void setOperations(List<AbstractOperation> operations) {
		this.operations = operations;
	}

}
