package it.univaq.di.choreos.synthesis.m2mtransformator;

import it.univaq.di.choreos.synthesis.datamodel.AbstractParticipant;
import it.univaq.di.choreos.synthesis.datamodel.CLTSModel;
import it.univaq.di.choreos.synthesis.datamodel.ChoreographyBPMNSpecification;
import it.univaq.di.choreos.synthesis.datamodel.Participant;

import java.util.List;

public interface M2MTransformator {
	
	CLTSModel bpmn2clts(ChoreographyBPMNSpecification bpmnchoreographyspecification) throws M2MTransformatorException;

	List<Participant> clts2coords(CLTSModel cltsModel) throws M2MTransformatorException;
	
	CLTSModel abstract2ConcreteCLTSModel(CLTSModel cltsModel, List<AbstractParticipant> participants) throws M2MTransformatorException;

}
