package org.ow2.choreos.chordevelopment.analysis.depanalyzer;

import org.ow2.choreos.chordevelopment.analysis.depanalyzer.analysis.antipattern.AntiPatternReport;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.entity.ChoreographySchema;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.algorithms.stability.StabilityCalculator;

import edu.uci.ics.jung.graph.DirectedGraph;

public class IntraChoreographyAnalyzer {

	private ChoreographySchema chorModel;
	
	public IntraChoreographyAnalyzer(ChoreographySchema chorModel){
		this.chorModel = chorModel;
	}
	
	public Double calculateOverallStability(ChoreographySchema chorModel) {
		
		//ChorModel --> appropriate graph representation
		//Maybe this will end up inside the Choreography class 
		DirectedGraph graph = null;
		
		StabilityCalculator stabilityCalculator = 
				new StabilityCalculator();
		
		Double stability = stabilityCalculator.calculateOverallStability(graph);		
		return stability;
	}
	
	public AntiPatternReport findAntiPatterns(ChoreographySchema chorModel){
		
		//ChorModel --> appropriate graph representation
		//Maybe this will end up inside the Choreography class
		DirectedGraph graph = null;
		
		AntiPatternReport antiPatternsReport = new AntiPatternReport(graph);
		return antiPatternsReport;
	}
	
	
}
