package org.ow2.choreos.chordevelopment.analysis.depanalyzer.entity;

public class CallChoreographyStep extends Step{

	private Choreography choreography;
	private boolean expanded;
	
	public CallChoreographyStep(String ID, Choreography choreography, 
			boolean expanded){
		
		this.choreography = choreography;
		this.expanded = expanded;
	}
	
	public Choreography getChoreography() {
		return choreography;
	}
	
	public boolean isExpanded(){
		return expanded;
	}
	
	@Override
	protected void plugIntoChoreography(ChoreographySchema chorSchema) {
		chorSchema.addCallChorStep(this);
	}
	
}