package org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.algorithms.centrality;

import java.util.HashMap;
import java.util.Map;

import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.entity.Edge;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.entity.Vertex;

import edu.uci.ics.jung.algorithms.scoring.ClosenessCentrality;
import edu.uci.ics.jung.graph.DirectedGraph;

public class ClosenessCentralityCalculator {

	/**
	 * TODO: write closeness centrality equation
	 * @return
	 */
	public Map<Vertex, Double> calculateVerticesClosenessCentrality(
			DirectedGraph<Vertex, Edge> graph){
	
		Map<Vertex, Double> centralities = new HashMap<Vertex, Double>();
		ClosenessCentrality<Vertex, Edge> ranker = 
				new ClosenessCentrality<Vertex, Edge>(graph);
		
		for(Vertex v : graph.getVertices()){
			centralities.put(v, ranker.getVertexScore(v));
		}

		return centralities;
	}
	
}
