package org.ow2.choreos.chordevelopment.analysis.depanalyzer.analysis.intra;

import static org.junit.Assert.*;

import org.junit.Test;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.entity.Participant;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.entity.util.AuctionHouseChoreography;

import edu.uci.ics.jung.graph.DirectedGraph;

public class ParticipantCallGraphTest {

	//@Test
	public void shouldBuildCallGraphForAuctionHouseChoreography(){

		ParticipantCallGraphBuilder callGraphBuilder = 
				new ParticipantCallGraphBuilder();
		
		DirectedGraph<Participant, ParticipantLink> callGraph = 
				callGraphBuilder.build(new AuctionHouseChoreography());
		
		System.out.println(callGraph);
		assertEquals(4, callGraph.getVertexCount());
	}
	
}