package it.univaq.di.choreos.coordinationprotocol.algorithm.model;

public class AdditionalMessage {

	private String coordinatedServiceEndpointName;
	private String choreographyID;
	
	private String request;
	private String coordinationDelegateFrom;
	private String coordinationDelegateTo;
	private String state;
	
	
	public AdditionalMessage() {
	}
	
	public AdditionalMessage(String coordinatedServiceEndpointName, String choreographyID, String request, String coordinationDelegateFrom, String coordinationDelegateTo, String state) {
		this.coordinatedServiceEndpointName = coordinatedServiceEndpointName;
		this.choreographyID = choreographyID;
		this.request = request;
		this.coordinationDelegateFrom = coordinationDelegateFrom;
		this.coordinationDelegateTo = coordinationDelegateTo;
		this.state = state;
	}

	public String getCoordinatedServiceEndpointName() {
		return coordinatedServiceEndpointName;
	}

	public void setCoordinatedServiceEndpointName(String coordinatedServiceEndpointName) {
		this.coordinatedServiceEndpointName = coordinatedServiceEndpointName;
	}

	public String getChoreographyID() {
		return choreographyID;
	}
	public void setChoreographyID(String choreographyID) {
		this.choreographyID = choreographyID;
	}
	public String getRequest() {
		return request;
	}
	public void setRequest(String request) {
		this.request = request;
	}
	public String getCoordinationDelegateFrom() {
		return coordinationDelegateFrom;
	}
	public void setCoordinationDelegateFrom(String coordinationDelegateFrom) {
		this.coordinationDelegateFrom = coordinationDelegateFrom;
	}
	public String getCoordinationDelegateTo() {
		return coordinationDelegateTo;
	}
	public void setCoordinationDelegateTo(String coordinationDelegateTo) {
		this.coordinationDelegateTo = coordinationDelegateTo;
	}
	public String getState() {
		return state;
	}
	public void setState(String state) {
		this.state = state;
	}

	@Override
	public String toString() {
		return "[coordinatedServiceEndpointName=" + coordinatedServiceEndpointName + ", choreographyID=" + choreographyID + ", request=" + request + ", coordinationDelegateFrom=" + coordinationDelegateFrom + ", coordinationDelegateTo=" + coordinationDelegateTo + ", state=" + state + "]";
	}

	
}
