package it.univaq.di.choreos.synthesis.behavioursimulator;


import java.util.List;

import it.univaq.di.choreos.synthesis.datamodel.CLTSModel;
import it.univaq.di.choreos.synthesis.datamodel.ELTSModel;


public interface BehaviourSimulator {
	 
	boolean simulation(ELTSModel firstELTSModel, ELTSModel secondELTSModel) throws BehaviourSimulatorException;
	
	ELTSModel projection(CLTSModel cltsModel, String participantName) throws BehaviourSimulatorException;
	
	List<ELTSModel> projections(CLTSModel cltsModel) throws BehaviourSimulatorException;
	
	 
}
