package it.univaq.di.choreos.synthesis.datamodel;

import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
@SuppressWarnings("serial")
public class ServiceDiscoveryInput implements java.io.Serializable {

	private String choreographyName;
	private String participant;
	private ELTSModel eltsModel;

	public ServiceDiscoveryInput() {
		super();
	}

	
	public ServiceDiscoveryInput(String choreographyName, String participant, ELTSModel eltsModel) {
		super();
		this.choreographyName = choreographyName;
		this.participant = participant;
		this.eltsModel = eltsModel;
	}


	public String getChoreographyName() {
		return choreographyName;
	}

	public void setChoreographyName(String choreographyName) {
		this.choreographyName = choreographyName;
	}

	public String getParticipant() {
		return participant;
	}

	public void setParticipant(String participant) {
		this.participant = participant;
	}

	public ELTSModel getEltsModel() {
		return eltsModel;
	}

	public void setEltsModel(ELTSModel eltsModel) {
		this.eltsModel = eltsModel;
	}

}
