package it.univaq.di.choreos.synthesis.m2mtransformator.rest;

import it.univaq.di.choreos.synthesis.Utility;
import it.univaq.di.choreos.synthesis.configuration.Configuration;
import it.univaq.di.choreos.synthesis.rest.RESTServer;

public class M2MTransformatorServer {
	
	public static String NAME;
	public static String URL;
	private RESTServer restServer;

	static {
		String port = Configuration.get(Configuration.SERVER_PORT);
		NAME = Configuration.get(Configuration.SERVER_NAME);
		URL = "http://" + Utility.getHostAddress() + ":" + port + "/m2mtransformator/";
	}

	public M2MTransformatorServer() {
		this.restServer = new RESTServer(NAME, URL, new Class[] { RestM2MTransformator.class });
	}

	public void start() {
		this.restServer.start();
	}

	public void stop() {
		this.restServer.stop();
	}

	public static void main(String[] args) throws InterruptedException {
		M2MTransformatorServer server = new M2MTransformatorServer();
		server.start();
	}

}

